; running line - idea (c) by Serge Pachkovksy

                     p586
                     model flat, stdcall
                     jumps
                     locals __
                     
                     include       ..\..\include\myapis.inc
                     include       ..\..\include\razno.inc
                     include       ..\..\include\useful.inc
                     include       ..\..\include\mz.inc
                     include       ..\..\include\pe.inc

PRODUKCIJA                                equ           1

;DEBUG                                     equ           1

RL_END_MARKER                             equ           0DEADC0DEh                  ; marker za kraj
XOR_BAJT		                     equ		023h
RL_START_MARKER                           equ           00BADC0DEh
MAXIMALNA_VELICINA_PROGRAMA               equ           1024
;SYSER_DEBUGGING                           equ           1
GDT_SELEKTOR                              equ           97
MAXIMALNA_VELICINA_PROGRAMA               equ           1024
MAXIMALNA_VELICINA_BF_POLJA               equ           30000-1
MAXIMALNA_VELICINA_STDOUT                 equ           500-1
MAX_DEKRIP_LEN                            equ           10

                     .data

                     db ?
                     
                     .code
                     
start:               
                     align 4

                     call          main                     

                     db            '$start'
                     
main                 proc          c

                     local         arg_end
                     local         fizicka_adresa:dword:2
                     local         access:byte:EXPLICIT_ACCESS_SIZE
                     local         objattr:OBJECT_ATTRIBUTES
                     local         modinfo
                     local         ntoskrnl
                     local         mem_section
                     local         p_sec_descr
                     local         p_old_dacl
                     local         p_new_dacl
                     local         mapped_size
                     local         map_base
                     local         sys_info

;       typedef struct _KGDTENTRY {
;          WORD LimitLow;                        // size in bytes of the GDT
;          WORD BaseLow;                         // address of GDT (low part)
;          WORD BaseHigh;                        // address of GDT (high part)
;       } KGDTENTRY, *PKGDTENTRY;

                     local         l_gdt_base:dword                    
                     local         l_gdt_limit:word
                     local         farcall:dword:2                           ; u biti treba 6 ali neka bude dword-aligned..
                     local         x
                     local         y
                     local         arg_start

align 4
                     @build_UNICODE_STRING <\Device\PhysicalMemory>
                     push          eax			

                     lea	       edi, arg_start
			lea	       ecx, arg_end
			sub	       ecx, edi
			xor	       eax, eax
			cld
			rep	       stosb                              ; vecina OBJECT_ATTRIBUTES polja su na 0 po defaultu
			
                     pop           edi
                     
                     mov           objattr.OBJETCT_ATTR_Length, OBJECT_ATTRIBUTES_SIZE
                     mov           objattr.OBJETCT_ATTR_Attributes, OBJ_CASE_INSENSITIVE + OBJ_KERNEL_HANDLE
                     mov           objattr.OBJETCT_ATTR_ObjectName, edi

                     @build_UNICODE_STRING <user32.dll>
                     xchg          esi, eax

                     ; aloirajmo memoriju za temp buffer od LDE32

                     @Ntmalloc     2048, ecx
                     jecxz         kraj

                     @get_delta    TMP_DLTA3, edx
                     mov           (lde_ptr TMP_DLTA3).dword ptr 0, ecx
       
                     ; inicijaliziraj interni 2K buffer od LDE32 (raspakiraj interne zastavice)
                     
                     push          ecx
                     call          disasm_init
                     add           esp, 4                                    ; trebas poravnati stog!
                     
                     mov           eax, dword ptr fs:[30h]
                     mov           eax, [eax+0ch]
                     mov           eax, [eax+1ch]
                     mov           ebx, [eax+8]                              ; uzmi bazu od ntdll.dll
                     
                     gethash      <LdrLoadDll>
                     push          hash
                     call          load_dll_address

                     xor           ebx, ebx
                     push          esp
                     push          esi
                     push          ebx
                     push          ebx
                     call          eax
                     pop           eax                                       ; baza od user32.dll

                     xor           edx, edx
                     push          edx
                     push          esp
                     push          ebx
                     @sysenter     NtUserOpenClipboard, 2
                     
                     pop           edx
                     test          eax, eax
                     jz            greska
                                          
                     push          MAXIMALNA_VELICINA_BF_POLJA+1
                     mov           edx, esp
                     xor           eax, eax                                  ; neka nam sistem dodijeli baznu adresu
                     push          eax
                     mov           ecx, esp
                     
                     push          PAGE_READWRITE                                  
                     push          MEM_COMMIT
                     push          edx
                     push          ebx                                       ; ZeroBits, 0 uvijek?
                     push          ecx                                       ; bazna adresa kako nam se dodijeli..
                     push          -1                                        ; trenutni proces
                     @sysenter     NtAllocateVirtualMemory, 6
                     pop           esi                                       ; bazna adresa koju smo dobili
                     pop           ecx                                       ; poravnaj stog

                     test          eax, eax
                     jnz           greska
                     push          esi                                       ; za kasnije
                     
                     push          MAXIMALNA_VELICINA_STDOUT+1
                     mov           edx, esp
                     xor           eax, eax                                  ; neka nam sistem dodijeli baznu adresu
                     push          eax
                     mov           ecx, esp
                     
                     push          PAGE_READWRITE
                     push          MEM_COMMIT
                     push          edx
                     push          ebx                                       ; ZeroBits, 0 uvijek.
                     push          ecx                                       ; bazna adresa kako nam se dodijeli..
                     push          -1                                        ; trenutni proces
                     @sysenter     NtAllocateVirtualMemory, 6
                     pop           esi                                       ; bazna adresa koju smo dobili
                     pop           ecx                                       ; poravnaj stog

                     test          eax, eax
                     jnz           greska
                     push          esi                                       ; za kasnije
                     
                     push          CF_TEXT                                    ; je li na clipboardu tekst?
                     @sysenter     NtUserIsClipboardFormatAvailable, 1
                     xchg          eax, ecx
                     jecxz         zatvori_clip  

                     push          ebx
                     push          ebx
                     push          ebx
                     push          esp                                             ; ptr na neku gubavu strukturu od 3 DWORD-a
                     push          CF_TEXT
                     @sysenter     NtUserGetClipboardData, 2                       ; uzmi handle na clipboard
                     test          eax, eax
                     jz            zatvori_clip                                    ; vraca handle, NULL u slucaju greske
                     add           esp, 4*3                                        ; pocisti stog, vraca tip koji *jest* dostupan
                     
                     mov           edi, eax

                     ; push eax
                     ; call user32!CreateLocalMemHandle
                     push          ebx                     
                     push          esp                                              ; 0 ili ako je buffer premal potrebna velicina buffera
                     push          ebx                                              ; velicina alocirane memorije
                     push          ebx                                              ; ptr na alociranu memoriju
                     push          eax                                              ; handle koji je vratio NtUserGetClipboardData
                     @sysenter     NtUserCreateLocalMemHandle, 4                    ; prvi nam put vraca STATUS_BUFFER_TO_SMALL
                     
                     ;pop           edx                                             ; potrebna velicina buffera, mislim da vraca alociranu velicinu
                     mov           edx, esp                                         ; ptr na potrebnu velicinu buffera
                     xor           ecx, ecx
                     push          ecx                                              ; neka nam sistem dodijeli baznu adresu
                     mov           ecx, esp

                     push          PAGE_READWRITE
                     push          MEM_COMMIT
                     push          edx
                     push          ebx                                       ; ZeroBits, 0 uvijek.
                     push          ecx                                       ; bazna adresa kako nam se dodijeli..
                     push          -1                                        ; trenutni proces
                     @sysenter     NtAllocateVirtualMemory, 6
                     
                     pop           esi                                       ; bazna adresa koju smo dobili
                     pop           ecx                                       ; poravnaj stog! neka na stogu ostane velicina alocirane memorije

                     test          eax, eax
                     jnz           greska
                     
                     push          ebx
                     push          ecx
                     push          esi                                       ; esi = ptr na clipboard buffer
                     push          edi
                     @sysenter     NtUserCreateLocalMemHandle, 4
                     
                     
                     
                     @get_delta    TMP_DLTA1, ecx

                     pop           (bf_sim_stdout_polje TMP_DLTA1).dword ptr 0
                     pop           (bf_sim_polje TMP_DLTA1).dword ptr 0
                     mov           (bf_sim_clip TMP_DLTA1).dword ptr 0, esi

                     ; esi = ptr na ulazni niz
                     ; edi = ptr na stdout
                     ; ebp = p
                     
                     @SEH_SetupRL   <call dekodiraj_seh>                            ; bejbe!
                     
                     call          brainfuck_provjeri_sintaksu, esi
                     
                     @SEH_RemoveFrame

                     test          eax, eax
                     jz            __izadji_normalno
                     
                     @Ntmalloc     SYSTEM_MODULE_INFORMATION_SIZE, ecx
                     jecxz         kraj
                     mov           modinfo, ecx
                     
                     @Ntmalloc     SYSTEM_BASIC_INFORMATION_SIZE, ecx   
                     jecxz         kraj
                     mov           sys_info, ecx

                     push          0
                     push          SYSTEM_BASIC_INFORMATION_SIZE
                     push          ecx
                     push          SystemBasicInformation
                     @sysenter     NtQuerySystemInformation, 4
              	
GetNtoskrnl:         push          0                                         ; enumemeriraj module
	              push          SYSTEM_MODULE_INFORMATION_SIZE
	              push          modinfo
	              push          SystemModuleInformation
	              @sysenter     NtQuerySystemInformation, 4
                     
                     
                     
                     mov           esi, modinfo                               ; eax = broj modula
                     lodsd                                                    ; esi = ptr na prvi modul
                     xchg          eax, ebx
                     
__loop:              mov           edi, esi
                     add           edi, SYSMOD_abName
                     
                     push          edi
                     call          MojPathFindFileName

IFDEF SYSER_DEBUGGING
                     ; kad je syser instaliran imamo kernel1.exe!
                     
                     mov           eax, 0804D7000h

                     mov           ntoskrnl, eax
                     jmp           __nasao_ntoskrnl
ENDIF                     
                     or            [eax], 20202020h                    ; pretvori u mala slova, 5. bit postavljen -> malo slovo
                     cmp           [eax], 'sotn'
                     jnz           __2
                     or            [eax+4], 20202020h
                     cmp           [eax+4], 'lnrk'
                     jnz           __2
                     or            [eax+8], 20202020h
                     cmp           [eax+8], 'exe.'
                     jnz           __2
                     
                     mov           eax, [esi.SYSMOD_pAddress]         ; imamo kernel!
                     mov           ntoskrnl, eax
                     jmp           __nasao_ntoskrnl

__2:                 add           esi, SYSTEM_MODULE_SIZE
                     dec           ebx
                     jns           __loop

                     jmp           $                                 ; nismo nasli kernel...major fuckup :/
              	
__nasao_ntoskrnl:    lea           eax, objattr
              	push          eax
              	push          WRITE_DAC + READ_CONTROL
              	lea           eax, mem_section
              	
              	push          eax
              	@sysenter     NtOpenSection, 3                   ; otvori handle na objekt
              	
              	mov           ebx, mem_section
              	
              	xor           ebx, ebx

                     @get_dll_api  advapi32.dll, GetSecurityInfo
                     
              	lea           ecx, p_sec_descr
              	push          ecx
              	push          ebx
              	lea           ecx, p_old_dacl
              	push          ecx   
              	push          ebx
              	push          ebx
              	push          DACL_SECURITY_INFORMATION
              	push          SE_KERNEL_OBJECT
              	push          mem_section
              	call          eax                                       ; uzmi sigurnosni deskriptor
              	
              	; modificiraj prava pristupa. Po defaultu samo Administrator/SYSTEM mogu pisati po \Device\PhysicalMemory
              	              	
	              mov		access.EXPACCESS_grfAccessPermissions, SECTION_ALL_ACCESS
	              inc           ebx
	              mov		access.EXPACCESS_grfAccessMode, ebx                       ; GRANT_ACCESS
	              mov		access.EXPACCESS_Trustee.TRUSTEE_TrusteeForm, ebx         ; TRUSTEE_IS_NAME
	              mov		access.EXPACCESS_Trustee.TRUSTEE_TrusteeType, ebx         ; TRUSTEE_IS_USER
	              dec           ebx

	              @pushsz       "CURRENT_USER"
	              pop		access.EXPACCESS_Trustee.TRUSTEE_ptstrName
              	
                    	@get_dll_api  advapi32.dll, SetEntriesInAclA
                    	xchg          eax, edx
              	
              	lea           ecx, p_new_dacl
              	push          ecx 
              	push          p_old_dacl
              	lodsd
              	push          esi                                       ; offset access
              	push          1
              	call          edx                                       ; stvori novi ACL
                     
                     @get_dll_api  advapi32.dll, SetSecurityInfo
                     
                     push          ebx
                     push          p_new_dacl
                     push          ebx
                     push          ebx
                     push          DACL_SECURITY_INFORMATION              
              	push          SE_KERNEL_OBJECT	
              	push          mem_section
              	call          eax                                       ; apdejtaj sigurnosni deskriptor sa novim ACL
                     
              	push          mem_section
              	@sysenter     NtClose, 1

              	; sad kad imamo r/w pristup, ponovno ga otvaramo
              	
              	lea           eax, objattr
              	push          eax
              	push          SECTION_MAP_READ + SECTION_MAP_WRITE
              	lea           eax, mem_section
              	push          eax
              	@sysenter     NtOpenSection, 3

                     @get_delta    TMP_DLTA5, edx
              	lea           eax, ring0_proc TMP_DLTA5
              	
              	mov           (callgatex TMP_DLTA5).word ptr 0, ax
             	
              	shr           eax, 16
              	mov           (callgatex+6 TMP_DLTA5).word ptr 0, ax  
              	
              	sgdt          (l_gdt_limit).fword ptr 0
             	
              	movzx         ebx, (l_gdt_limit).word ptr 0           ; 3FFh
              	mov           eax, l_gdt_base-2                       ; 8003F000h
              	
              	call		GetPhysicalAddress
              	mov		fizicka_adresa, eax
               
                     mov		eax, l_gdt_base-2
              	xor		edx, edx
              	push		eax
              	mov           ecx, sys_info
              	add           ecx, SYS_BASIC_INFO_AllocationGranularity             ; 10000
              	mov           ecx, [ecx]
              	div           ecx
              	mov		edi, edx
              	pop		eax
              	inc		ebx
              	mov		esi, ebx				        ; mapirana velicina
              	add		esi, edi
              	sub		eax, edi
              	call		GetPhysicalAddress
              	
              	mov		fizicka_adresa, eax
              	mov		mapped_size, esi
              	mov		ecx, mem_section
              	
              	push          PAGE_READWRITE
              	push          0
              	push          1
              	lea           eax, mapped_size
              	push          eax
              	lea           eax, fizicka_adresa
              	push          eax
                   	push          esi
              	push          0
              	lea           eax, map_base
              	push          eax
              	push          -1
              	push          ecx
              	@sysenter     NtMapViewOfSection, 10

                     @get_delta    TMP_DLTA6, ecx
              	
              	add		map_base, edi
                     mov		eax, map_base
              	push		(callgatex TMP_DLTA6).dword ptr 0
              	pop		dword ptr [eax+GDT_SELEKTOR*8]
              	push		(callgatex+4 TMP_DLTA6).dword ptr 0
              	pop		dword ptr [eax+GDT_SELEKTOR*8+4]                 ; instaliraj nas ring0 kod u gdt, u zapis #GDT_SELEKTOR
              	
              	mov		(farcall+4).word ptr 0, GDT_SELEKTOR*8+3	       ; nas callgate selektor
              
	              lea           eax, ring0_proc TMP_DLTA6
	              push          eax
	              mov           eax, esp
	              
	              push          ring0_end - ring0_proc 
	              mov           edx, esp
              
              	push          MAP_PROCESS
	              push          edx                                              ; lockamo kod i tako smanjujemo vjerojatnost da ce biti
	              push          eax                                              ; outpage-an
                     push          -1                                               ; trenutni proces
	              @sysenter     NtLockVirtualMemory, 4 
	              add           esp, 8
	              
	              
	              
;	              @get_dll_api  user32, MessageBoxA
;	              
;	              push          0
;	              @pushsz       "picim u ring0!"
;	              @pushsz       "weeeeeeeeee"
;	              push          0
;	              call          eax
                     
	              call          fword ptr farcall
                     
;                     @get_dll_api  user32, MessageBoxA
;                     
;                     push          0
;	              @pushsz       "vracam se iz ring0!"
;	              @pushsz       "weeeeeeeeee"
;	              push          0
;	              call          eax
                     
	              @get_delta    TMP_DLTA7, ecx
	              lea           eax, ring0_proc TMP_DLTA7
	              push          eax
	              mov           eax, esp
	              
	              push          ring0_end - ring0_proc 
	              mov           edx, esp	              
                     
                     push          MAP_PROCESS
	              push          edx
	              push          eax
                     push          -1                                        ; trenutni proces
	              @sysenter     NtUnlockVirtualMemory, 4
	              add           esp, 8

	              push          map_base
	              push          -1
	              @sysenter     NtUnmapViewOfSection, 2

	              push          mem_section
	              @sysenter     NtClose, 1
	              
	              @Ntfree       SYSTEM_MODULE_INFORMATION_SIZE, modinfo

	              @Ntfree       SYSTEM_INFO_SIZE, sys_info

	              
;poruka:              @get_dll_api  user32, MessageBoxA
;
;                     push          0
;                     @pushsz       "checkpoint!"
;                     @pushsz       "checkpoint!"
;                     push          0
;                     call          eax
                     
__izadji_normalno:   
                     
zatvori_clip:        @sysenter     NtUserCloseClipboard, 0
                     
                     jmp           kraj                     
                     
greska:              ;int 3
                     jmp           $

kraj:                push          ebx
                     push          -1
                     @sysenter     NtTerminateProcess, 2

main                 endp


dekodiraj_seh        proc          c

                     arg           eh:Except_Handler

                     pusha
                     
                     mov           eax, eh.EH_ExceptionRecord
                     cmp           dword ptr [eax.ER_ExceptionCode], EXCEPTION_SINGLE_STEP
                     jnz           __kraj                                           ; ako nije ss izadji iz handlera

                     mov           ebx, eh.EH_ContextRecord
                     mov           edi, [ebx.CONTEXT_Eip]
                     cmp           dword ptr [edi], RL_END_MARKER
                     jz            __RL_END_MARKER

                     or            [ebx.CONTEXT_EFlags], 100h                       ; inace i dalje ostavi TF

                     cmp           dword ptr [edi], RL_START_MARKER
                     jnz           __nije_pocetak

                     ; e sad smo prije pocetka koda kojeg trebamo en/dekriptirati
                     
                     add           [ebx.CONTEXT_Eip], 4                             ; preskoci RL_START_MARKER
                     add           edi, 4
 
                     ; dekriptiramo 10 instrukcija, izracunavamo duljinu prve te je spremamo u varijablu i reenkriptiramo

                     ; ok za komentirati?                     
;                     mov           preth_instr_len, 2                               ; hard-coded za prvu instr. dodaj LDE32 ovdje ;)
                     
__nije_pocetak:      ; dekriptiraj prvih MAX_DEKRIP_LEN bajtova
                     
                     push          MAX_DEKRIP_LEN
                     pop           ecx
                     
                     xor           edx, edx
__dekrip_lde:        xor           byte ptr [edx+edi], XOR_BAJT
                     inc           edx
                     loop          __dekrip_lde
                     
                     @get_delta    TMP_DLTA4, edx
                     
                     push          edi
                     push          (lde_ptr TMP_DLTA4).dword ptr 0
                     call          disasm_main
                     add           esp, 8
                     
                     inc           eax
                     jz            __error
                     dec           eax                                ; duljina prve instrukcije 
                     
                     mov           esi, (preth_instr_len TMP_DLTA4).dword ptr 0
                     
                     ; UVIJEK spremamo offset prosle instrukcije u varijablu zbog mogucih grananja i inih picki materina...
                     
                     push          (offset_prosla TMP_DLTA4).dword ptr 0                       ; spremi staru vrijednost skoka
                     mov           (offset_prosla TMP_DLTA4).dword ptr 0, edi
                     
                     mov           (preth_instr_len TMP_DLTA4).dword ptr 0, eax               ; spremi za kasnije
                     push          MAX_DEKRIP_LEN
                     pop           ecx
                     sub           ecx, eax                           ; MAX_DEKRIP_LEN - (duljina sljedece instrukcije) 
                     add           edi, eax                           ; ostatak nazad kriptiramo
                     xor           edx, edx
                     
__krip_lde:          xor           byte ptr [edx+edi], XOR_BAJT
                     inc           edx
                     loop          __krip_lde
                     
                     pop           edx                                ; edx = vrijednost starog offset_prosla
                     
                     ; jos moramo kriptirati i prethodnu instrukciju. u slucaju da je to RL_START_MARKER to ne radimo
                     sub           edi, eax
                     cmp           [edi-4], RL_START_MARKER
                     jz            __kraj
                     
                     ; ecx = 0 samo u slucaju prve instr.
                                          
                     mov           ecx, edx
                     jecxz         __nije_prosla_skok
                     mov           edi, ecx
                     jmp           __1

__nije_prosla_skok:  sub           edi, esi
__1:                 mov           ecx, esi                                         ; duljina prethodne instrukcije
                     xor           edx, edx
__krip_ldey:         xor           byte ptr [edx+edi], XOR_BAJT
                     inc           edx
                     loop          __krip_ldey
                     
                     jmp           __kraj
                     
__RL_END_MARKER:     add           [ebx.CONTEXT_Eip], 4                         ; preskoci RL_END_MARKER
                     and           [ebx.CONTEXT_EFlags], 0FFFFFEFFh                 ; makni trap flag
                     jmp           __kraj
       
__error:             jmp           $             
__kraj:              popa
                     xor           eax, eax                                         ; ne radi ako manualo leave, add esp, 4, retn!!
                     ret
;                    
dekodiraj_seh        endp

udji_ss              proc          near
                     pop           eax
                     pushf
                     or            byte ptr [esp+1], 1
                     popf
                     jmp eax                                      ; prva se instrukcija ne trace-a                                              
udji_ss              endp

	callgatex		dw	0						; donji dio adrese
				dw	KGDT_R0_CODE					; NT ring0 selektor
				dw	1110110000000000b		              ; misc bitovi (5 najnizih = # parametara)
				dw	0	


; ********************************************
; POCETAK STRPAJ U RING0 KOD!
; ********************************************

ring0_proc:          pushf
                     pusha
                     
; Moramo fs postaviti na 30h jer sistem ocekuje ds fs registar pokazuje na Processor Control Region kad se nit izvodi u ring0, 
; a selektor 30h pokazuje na deskriptor cija je bazna adresa jednaka adresi PCR-a.
                     
                     push          fs
                     mov           ebx, 30h
                     mov           fs, bx
                     
; Stvori nesto malo prostora na stogu, prolog standardni. Ovaj korak *moramo* napraviti jer je vezan za logiku kojom radi page fault
; handler. Inace cemo dobiti BSOD.

                     sub           esp, 50h
                     mov           ebp, esp
                     
; postavi exception frame na NULL, spremi stari na stog

                     mov           edx, cs:[0FFDFF000h]
                     mov           ds:[0FFDFF000h], 0FFFFFFFFh
                     mov           [ebp], edx

; Spremi neka polja u TEB koja SoftIce zove "KSS EBP" (Kernel Stack Segment?); ovo moramo uraditi te ovo polje postaviti na trap frame 
; stvoren u prethodnom koraku.
                     
                     mov           esi, cs:[0FFDFF124h]                      ; FFDFF124h = threnutni ETHREAD blok!
                     mov           edx, [esi+128h]                           ; KTRAP_FRAME *TrapFrame
                     mov           [ebp+4], edx                              ; spremi stari trap frame na stog
                     mov           [esi+128h], ebp                           ; i postavi novi

; spremi vrijeme kernela i thread mode (kernel/user)

                     mov           edi, [esi+137h]                           ;  uint32   KernelTime (138h???)
                     mov           [ebp+8], edi
                     
; postavi thread mode (kernel/user) baziran na selektoru koda

                     and           dword ptr [esi+137h], 1
                     
                     @get_delta    TMP_DLTA2, ecx

			mov           edi, (bf_sim_stdout_polje TMP_DLTA2).dword ptr 0

                     push          edi
                     push          (bf_sim_polje TMP_DLTA2).dword ptr 0
                     push          (bf_sim_clip TMP_DLTA2).dword ptr 0
                     call          brainfuck_simuliraj2

			xor	       eax, eax				              ; inicijalizacija hasha

__1:			rol	       eax, 7
			xor	       al, [edi]
			inc	       edi					              ; slovo po slovo
			cmp	       byte ptr [edi], 0
			jnz	       __1

IFDEF                PRODUKCIJA

                     gethash       <ph34rl355>                                      ; y0 dudez! =)
                     mov           ebx, hash
                     xor           ebx, eax
                     jz            ok_pass
                     
                     ;oh joy, we're being cracked! :o)
                     
                     call          get_ntoskrnl
                     mov           ebx, eax

                     gethash       <KeBugCheckEx>
                     push          hash
                     call          load_dll_address
                     call		eax, 0bAdc0Deh, 0Badh, 0c0deh, 0Badh, 0c0deh, 0Badh     ; bad code ;)                     
        
                     ; nisam bas bio puno mashtovit ;)
                     
ok_pass:             call          get_ntoskrnl
                     mov           ebx, eax

                     gethash       <KeBugCheckEx>
                     push          hash
                     call          load_dll_address
                     
                     ; "challenge completed!" = 63 68 61 6C 6C 65 6E 67 65 20 63 6F 6D 70 6C 65 74 65 64 21
                     
                     call		eax, 06368616Ch, 06C656E67h, 06520636Fh, 06D706C65h, 074656421h                 
ENDIF                     
                    
; vrati KSS EBP
                     mov           esi, cs:[0FFDFF124h]
                     mov           ebx, [ebp+4]
                     mov           [esi+128h], ebx
                     
; vrati exception frame

                     mov           ebx, [ebp]
                     mov           fs:[0], ebx
                                          
; vrati thread mode

                     mov           ebx, [ebp+8]
                     mov           esi, fs:[124h]
                     mov           byte ptr [esi+137h], bl
                     add           esp, 50h
                     pop           fs

                     popa
                     popf
                     retf          ;4                                  ; 1 parametar!
                    
; ---------------------------------------------------------------------------
; Trazi bazu od ntoskrnl.exe koristeci mid-delta metodu. Pocetna adresa jest
; adresa prvog zapisa u IDT koji se uvijek nalazi negdje unutar ntoskrnl.exe
; Mozemo koristiti sidt, ali posto se IDT referencira uvijek sa ptr-om na 
; adresi FFDFF038, mozemo ga koristiti direktno.
; i: r0
;
; o: eax = baza od ntoskrnl.exe. 
; NB: na XP SP2 ntoskrnl.exe se nalazi na adresi 804D7000
; ---------------------------------------------------------------------------
get_ntoskrnl:

IFDEF SYSER_DEBUGGING
                     mov           eax, 0804D7000h
                     retn
ENDIF        
                     
                     pusha
                     
                     mov           esi, ds:[0FFDFF038h]
                     lodsd                                            ; esi = ptr na IDT
                     cdq
                     lodsd                                            ; eax = ptr na neku adresu unutar ntoskrnl.exe
                     and           eax, -1 shl 12                     ; poravnaj na 1 page
                     add           eax, 1000h
                     
__loop:              sub           eax, 1000h
                     cmp           [eax], 00905a4dh                   ; provjeri 'MZ' signaturu                     
                     jnz           __loop
                     mov           [esp.Pushad_eax], eax
                     popa
                     
                     retn

; ---------------------------------------------------------------------------
; searches for the address of specified API by export table scanning, r3/r0
; i: ebx = dll imagebase
;    TOS = API hash
;
; o: eax = API's address, 0 on error
; ---------------------------------------------------------------------------
load_dll_address:	pusha

			mov	       ecx, [ebx.MZ_lfanew]			; take RVA of PE header
			mov	       ecx, [ecx+ebx.NT_OptionalHeader.OH_DirectoryEntries.DE_Export.DD_VirtualAddress]
			jecxz	       __err					; check whether there is export directory RVA

			add	       ecx, ebx				; if so, normalize with imagebase
			xor	       esi, esi				; initialize counter
__k_l:			lea	       edx, [4*esi+ebx]
			add	       edx, [ecx.ED_AddressOfNames]	; take ptr to array of ptrs to functions names
			mov	       edx, [edx]				; take RVA of ptr to name of the API
			add	       edx, ebx				; normalize
			xor	       eax, eax				; initialize hash

__1:			rol	       eax, 7					; hash algo starts here. (x) by z0mbie
			xor	       al, [edx]
			inc	       edx					; next letter
			cmp	       byte ptr [edx], 0			; end of name?
			jnz	       __1					; nope, repeat again

			cmp	       eax, [esp.cPushad.Arg1]	       ; compare it with given hash; skip pushad+call+param
			jz	       __bingo				; yippie
       
			inc	       esi					; counter++
			cmp	       esi, [ecx.ED_NumberOfNames]		; compare counter with the number of exported functions
			jb	       __k_l					; if below, repeat it

__err:			xor	       eax, eax				; either exception occured, or we didn't find API. either way, set return value to false
			jmp	       __end

__bingo:		mov	       edx, [ecx.ED_AddressOfOrdinals]	; take RVA to array of API ordinals
			add	       edx, ebx				; normalize
			movzx	       edx, word ptr [edx+esi*2]		; x2 coz its an array of WORDs
			;sub	       edx, [ecx.ED_BaseOrdinal]
			mov	       eax, [ecx.ED_AddressOfFunctions]	; take RVA of an array of APIs addresses
			add	       eax, ebx				; normalize
			mov	       eax, [eax+edx*4]			; x4 coz its an array of DWORDs
			add	       eax, ebx				; normalize

__end:			mov	       [esp.Pushad_eax],eax			; set return address
			popa

                     retn          (Pshd)
                     
lde_ptr              dd            0
preth_instr_len      dd            0
offset_prosla        dd            0                                  ; ako prosla instrukcija nije bila skok -> 0, inace offset instrukcije

brainfuck_simuliraj2         proc   pascal      uses ebx esi edi

                     arg           clip
                     arg           polje
                     arg           stdout_polje
              
                     local         len
                     local         bf_stdout
                     
                     nop
                     
;                     db            '$start'
              
         		xor	       eax, eax
    
       		mov	       edx, clip
       		mov	       len, eax
       		xor	       eax, eax
       		jmp	       __tmp

__1:		       inc	       len
		       inc	       eax

__tmp:		       cmp	       eax, MAXIMALNA_VELICINA_PROGRAMA
       		jge	       __chk_len
       		cmp	       byte ptr [edx+eax], 0
       		jnz	       __1

__chk_len:	       cmp	       len, MAXIMALNA_VELICINA_PROGRAMA-1
                     
       		jnz	       __len_ok
       		xor	       eax, eax
       		jmp	       __izlaz

__len_ok:	       mov	       ecx, stdout_polje
       		xor	       esi, esi
       		mov	       bf_stdout, ecx
       		xor	       ecx, ecx
       		xor	       eax, eax
       		cmp	       eax, len
       		jge	       __izlaz1

__loop:	       movsx	       ebx, byte ptr [edx+eax]
       		cmp	       ebx, '+'
       		jnz	       __2
       		mov	       ebx, polje
       		inc	       byte ptr [ebx+esi]
       		jmp	       __provjera

__2:		       movsx	       ebx, byte ptr [edx+eax]
       		cmp	       ebx, '-'
       		jnz	       __3
       		mov	       ebx, polje
       		dec	       byte ptr [ebx+esi]
       		jmp	       __provjera

__3:		       movsx	       ebx, byte ptr [edx+eax]
       		cmp	       ebx, '>'
       		jnz	       __4
       		inc	       esi
       		jmp	       __provjera

__4:		       cmp	       ebx, '<'
       		jnz	       __5
       		dec	       esi
       		jmp	       __provjera

__5:		       cmp	       ebx, '['
       		jnz	       __6
       		mov	       ebx, polje
       		cmp	       byte ptr [ebx+esi], 0
       		jnz	       __provjera
       		inc	       eax
       		jmp	       __loopie

__pici_naprid:
                     movsx	       ebx, byte ptr [edx+eax]
       		cmp	       ebx, '['
       		jnz	        __shittie
       		inc	       ecx

__shittie:    	cmp	       ebx, ']'
       		jnz	        __y
       		dec	       ecx

__y:    	       inc	       eax

__loopie:     	test	       ecx, ecx
       		jg	       __pici_naprid
       		movsx	       ebx, byte ptr [edx+eax]
       		cmp	       ebx, ']'
       		jnz	       __pici_naprid
       		jmp	       __provjera

__6:   		movsx	       ebx, byte ptr [edx+eax]
       		cmp	       ebx, ']'
       		jnz	       __7
       		dec	       eax
       		jmp	       __loopie2


__naprid_jos:		movsx	       ebx, byte ptr [edx+eax]
       		cmp	       ebx, ']'
       		jnz	       __z
       		inc	       ecx

__z:	       	cmp	       ebx, '['
		       jnz	       __temp
		       dec	       ecx

__temp:	       dec	       eax

__loopie2:	       test	       ecx, ecx
       		jg	       __naprid_jos
       		movsx	       ebx, byte ptr [edx+eax]
       		cmp	       ebx, '['
       		jnz	       __naprid_jos
       		dec	       eax
       		jmp	       __provjera

__7:		       movsx	       ebx, byte ptr [edx+eax]
       		cmp	       ebx, '.'
       		jnz	       __provjera
       		mov	       ebx, polje
       		mov	       edi, bf_stdout
       		mov	       bl, [ebx+esi]
       		mov	       [edi], bl
       		inc	       bf_stdout

__provjera:	       inc	       eax
       		cmp	       eax, len
       		jl	       __loop

__izlaz1:	       mov	       eax, 1

;                     db            '$end'

__izlaz:	       ret
		
brainfuck_simuliraj2        endp

bf_sim_clip                 dd            0
bf_sim_polje                dd            0
bf_sim_stdout_polje         dd            0

ring0_end:

; ********************************************
; KRAJ STRPAJ U RING0 KOD!
; ********************************************


; jednostavna zamjena za MmGetPhysicalAddress:
; 1) 0x80000000 <= BaseAddress < 0xA0000000 : apliciramo masku 0x1FFFF000 na virtualnu adresu
; 2) BaseAddress < 0x80000000 && BaseAddress >= 0xA0000000 : trebamo nazalost citati cr3 :( 
;    umjesto toga, pokusavamo je pogoditi koristeci maskirajuci byte offset i ostavljajuci masku za indeks direktorija:

GetPhysicalAddress:
	              cmp		eax, 80000000h
	              jae		__1
	              cmp		eax, 0A0000000h
	              jb		__1
	              and		eax, 0FFFF000h
	              retn

__1:	              and		eax, 1FFFF000h
	              retn

; moja lite verzija PathFindFileName :>
    
MojPathFindFileName     proc          c

                     arg           pPath

		       mov           ecx, pPath
		       mov	       edx, ecx
                     jecxz         __izlaz
		       jmp	       __zapocni_petlju

__loop:	       cmp	       byte ptr [ecx], '\'
		       jnz	       __pov_brojac
                     cmp	       byte ptr [ecx+1], 0
		       jz	       __pov_brojac
		       mov	       edx, ecx
		       inc	       edx

__pov_brojac:        inc	       ecx

__zapocni_petlju:	cmp	       byte ptr [ecx],	0
                     jnz	       __loop

__izlaz:	       xchg          eax, edx
		       ret
MojPathFindFileName    endp

brainfuck_provjeri_sintaksu        proc   pascal      uses ebx

                     arg           p
                     
                     call          udji_ss
                     
                     dd            RL_START_MARKER

db 0a8h, 06eh, 02bh, 0a8h, 0e2h, 0c8h, 008h, 02ch
db 09dh, 033h, 0a0h, 0d9h, 008h, 057h, 001h, 0a0h
db 0d9h, 00eh, 057h, 03eh, 0a0h, 0d9h, 01fh, 057h
db 03bh, 0a0h, 0d9h, 01dh, 057h, 030h, 0a0h, 0d9h
db 078h, 057h, 02dh, 0a0h, 0d9h, 07eh, 057h, 02ah
db 0a0h, 0d9h, 00dh, 057h, 027h, 010h, 0e3h, 0c8h
db 010h, 063h, 0a3h, 01bh, 023h, 056h, 0f3h, 010h
db 0f8h, 0a8h, 0e2h, 0c8h, 033h, 02ch, 09dh, 0e9h
db 0a0h, 0dah, 078h, 056h, 022h, 060h, 0a0h, 0dah
db 07eh, 056h, 022h, 068h, 063h, 0a9h, 033h, 0a7h
db 0f1h, 056h, 0c9h, 0a6h, 0f8h, 057h, 027h, 010h
db 0e3h, 0c8h, 02ah, 09bh, 022h, 023h, 023h, 023h

                     dd            RL_END_MARKER
              
	              ret
		
brainfuck_provjeri_sintaksu endp

; LDE32BIN.INC -- Length-Disassembler Engine //32-bit
; 1.06
; generated file. do not edit
disasm_init:
db 060h,08Bh,07Ch,024h,024h,0FCh,033h,0C0h
db 050h,050h,050h,068h,000h,0A8h,0AAh,002h
db 068h,07Fh,068h,0FFh,03Fh,068h,0A0h,0DEh
db 0E6h,0FFh,068h,0FFh,0FFh,0D5h,0DBh,068h
db 0AAh,0AAh,0FEh,0FFh,068h,0AAh,0AAh,0AAh
db 0AAh,068h,000h,000h,0AAh,0AAh,050h,050h
db 050h,050h,050h,050h,068h,054h,001h,000h
db 000h,068h,055h,0F5h,0FFh,041h,068h,0AAh
db 0DDh,0DEh,055h,068h,011h,051h,095h,019h
db 068h,0FFh,01Fh,011h,011h,068h,0AAh,0FFh
db 011h,0FAh,068h,096h,0CFh,060h,08Eh,068h
db 0AAh,0D6h,072h,0FCh,068h,088h,0AAh,0AAh
db 0AAh,068h,0D5h,088h,088h,088h,068h,09Bh
db 055h,08Dh,052h,068h,053h,0D5h,06Ch,036h
db 068h,0FFh,055h,055h,035h,068h,0F9h,0D6h
db 0FEh,0FFh,068h,088h,088h,088h,068h,068h
db 088h,088h,088h,088h,068h,0CAh,047h,053h
db 08Dh,068h,0DFh,07Bh,0C6h,0DCh,068h,0AAh
db 0AAh,0AAh,0AAh,068h,0AAh,0AAh,0AAh,0AAh
db 068h,0FDh,04Fh,0A9h,0ABh,068h,0EAh,0FEh
db 0A7h,0D4h,068h,029h,075h,0FFh,053h,068h
db 0FEh,0A7h,0A4h,0FFh,068h,04Ah,0FAh,09Fh
db 092h,068h,0FFh,029h,0E9h,07Fh,0B9h,000h
db 002h,000h,000h,033h,0DBh,033h,0C0h,0E8h
db 014h,000h,000h,000h,0ABh,0E2h,0F6h,061h
db 0C3h,00Bh,0DBh,075h,007h,05Dh,05Eh,05Ah
db 056h,055h,0B3h,020h,04Bh,0D1h,0EAh,0C3h
db 0E8h,0ECh,0FFh,0FFh,0FFh,00Fh,083h,07Fh
db 000h,000h,000h,0E8h,0E1h,0FFh,0FFh,0FFh
db 073h,003h,0B4h,040h,0C3h,0E8h,0D7h,0FFh
db 0FFh,0FFh,072h,057h,0E8h,0D0h,0FFh,0FFh
db 0FFh,073h,04Dh,0E8h,0C9h,0FFh,0FFh,0FFh
db 073h,043h,0E8h,0C2h,0FFh,0FFh,0FFh,072h
db 025h,0E8h,0BBh,0FFh,0FFh,0FFh,073h,003h
db 0B0h,020h,0C3h,0E8h,0B1h,0FFh,0FFh,0FFh
db 073h,005h,066h,0B8h,002h,020h,0C3h,0E8h
db 0A5h,0FFh,0FFh,0FFh,073h,005h,066h,0B8h
db 008h,010h,0C3h,0B4h,003h,0C3h,0E8h,096h
db 0FFh,0FFh,0FFh,073h,003h,0B4h,060h,0C3h
db 0E8h,08Ch,0FFh,0FFh,0FFh,073h,003h,0B0h
db 018h,0C3h,0B4h,002h,0C3h,0B4h,080h,0C3h
db 0B4h,001h,0C3h,0E8h,079h,0FFh,0FFh,0FFh
db 073h,00Dh,0E8h,072h,0FFh,0FFh,0FFh,073h
db 003h,0B0h,008h,0C3h,0B4h,041h,0C3h,0B4h
db 020h,0C3h,0E8h,062h,0FFh,0FFh,0FFh,014h
db 000h,048h,0C3h
disasm_main:
db 060h,08Bh,074h,024h,024h,08Bh,04Ch,024h
db 028h,033h,0D2h,033h,0C0h,080h,0E2h,0F7h
db 08Ah,001h,041h,00Bh,014h,086h,0F6h,0C2h
db 008h,075h,0F2h,03Ch,0F6h,074h,036h,03Ch
db 0F7h,074h,032h,03Ch,0CDh,074h,03Bh,03Ch
db 00Fh,074h,044h,0F6h,0C6h,080h,075h,052h
db 0F6h,0C6h,040h,075h,073h,0F6h,0C2h,020h
db 075h,054h,0F6h,0C6h,020h,075h,05Ch,08Bh
db 0C1h,02Bh,044h,024h,028h,081h,0E2h,007h
db 007h,000h,000h,002h,0C2h,002h,0C6h,089h
db 044h,024h,01Ch,061h,0C3h,080h,0CEh,040h
db 0F6h,001h,038h,075h,0CEh,080h,0CEh,080h
db 0EBh,0C9h,080h,0CEh,001h,080h,039h,020h
db 075h,0C1h,080h,0CEh,004h,0EBh,0BCh,08Ah
db 001h,041h,00Bh,094h,086h,000h,004h,000h
db 000h,083h,0FAh,0FFh,075h,0ADh,08Bh,0C2h
db 0EBh,0CDh,080h,0F6h,020h,0A8h,001h,075h
db 0A7h,080h,0F6h,021h,0EBh,0A2h,080h,0F2h
db 002h,0F6h,0C2h,010h,075h,0A4h,080h,0F2h
db 006h,0EBh,09Fh,080h,0F6h,002h,0F6h,0C6h
db 010h,075h,09Ch,080h,0F6h,006h,0EBh,097h
db 08Ah,001h,041h,08Ah,0E0h,066h,025h,007h
db 0C0h,080h,0FCh,0C0h,00Fh,084h,07Bh,0FFh
db 0FFh,0FFh,0F6h,0C2h,010h,075h,02Dh,03Ch
db 004h,075h,005h,08Ah,001h,041h,024h,007h
db 080h,0FCh,040h,074h,017h,080h,0FCh,080h
db 074h,00Ah,066h,03Dh,005h,000h,00Fh,085h
db 059h,0FFh,0FFh,0FFh,080h,0CAh,004h,0E9h
db 051h,0FFh,0FFh,0FFh,080h,0CAh,001h,0E9h
db 049h,0FFh,0FFh,0FFh,066h,03Dh,006h,000h
db 074h,00Eh,080h,0FCh,040h,074h,0EDh,080h
db 0FCh,080h,00Fh,085h,035h,0FFh,0FFh,0FFh
db 080h,0CAh,002h,0E9h,02Dh,0FFh,0FFh,0FFh

db                   '$end'

end start



